defmodule PapayaCables do
  @moduledoc """
  Documentation for PapayaCables.
  """

  @doc """
  Hello world.

  ## Examples

      iex> PapayaCables.hello()
      :world

  """
  defstruct([:cable])

  def(new(host)) do
    {:ok, cable} = Cables.new(host)
    %__MODULE__{cable: cable}
  end

  defimpl(PapayaTransport.ApiTransport, for: __MODULE__) do
    def(send_message(%PapayaCables{cable: cable}, path, msg)) do
      {:ok, %Cables.Response{body: body}} = Cables.post(cable, path, [], msg)
      body
    end
  end
end
